/**********************************************************************
  ߃fR[h  bit0-5=0b11xxxx
  $Id: op_3x_func.c,v 1.2 2002/05/12 13:52:27 tane Exp $
**********************************************************************/
#include <math.h>
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int op_30_func( struct MACHINE_RESOURCE *mres , int mode ) /* lfs */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    fprintf(simmsgfp,"\t%%r%d, %%r%d, %d\n",r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchf4b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_31_func( struct MACHINE_RESOURCE *mres , int mode ) /* lfsu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchf4b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}



int op_32_func( struct MACHINE_RESOURCE *mres , int mode ) /* lfd */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchd8b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_33_func( struct MACHINE_RESOURCE *mres , int mode ) /* lfdu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchd8b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}



int op_34_func( struct MACHINE_RESOURCE *mres , int mode ) /* stfs */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storef4b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_35_func( struct MACHINE_RESOURCE *mres , int mode ) /* stfsu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storef4b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}



int op_36_func( struct MACHINE_RESOURCE *mres , int mode ) /* stfd */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    stored8b(mres->FPR[r1].f,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_37_func( struct MACHINE_RESOURCE *mres , int mode ) /* stfdu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(simmsgfp,r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    stored8b(mres->FPR[r1].f,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_3b_func( struct MACHINE_RESOURCE *mres , int mode ) /* 3b */
{
  int op_dec_bit27to30 ;
  op_dec_bit27to30=(mres->inst & 0x01e)>>1 ;

  if( DO_EXEC_DIS(mode) ){
    fprintf(simmsgfp,"%s",
	    op_3b_subfunc_tbl[op_dec_bit27to30].name) ;
  }
  if( DO_EXEC_INST(mode) ){
    op_3b_subfunc_tbl[op_dec_bit27to30].count++ ;
  }
  return( op_3b_subfunc_tbl[op_dec_bit27to30].func(mres,mode) ) ;
}


int op_3f_func( struct MACHINE_RESOURCE *mres , int mode ) /* 3f */
{
  int op_dec_bit ;
  
  op_dec_bit=(mres->inst & 0x00000020) ;
  if( op_dec_bit==0 ){
    op_dec_bit=(mres->inst & 0x000003fe)>>1 ;
    if( DO_EXEC_DIS(mode) ){
      fprintf(simmsgfp,"%s",
	      op_3f_subfunc0_tbl[op_dec_bit].name) ;
    }
    if( DO_EXEC_INST(mode) ){
      op_3f_subfunc0_tbl[op_dec_bit].count++ ;
    }
    return( op_3f_subfunc0_tbl[op_dec_bit].func(mres,mode) ) ;
  }else{
    op_dec_bit=(mres->inst & 0x0000001e)>>1 ;
    if( DO_EXEC_DIS(mode) ){
      fprintf(simmsgfp,"%s",
	      op_3f_subfunc1_tbl[op_dec_bit].name) ;
    }
    if( DO_EXEC_INST(mode) ){
      op_3f_subfunc1_tbl[op_dec_bit].count++ ;
    }
    return( op_3f_subfunc1_tbl[op_dec_bit].func(mres,mode) ) ;
  }
  return(0) ;
}
