/**********************************************************************
  fork G~[V
  $Id: sim_fork.c,v 1.2 2002/05/30 15:57:31 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	sim_fork( struct PROCESS_LIST *proc_list )
{
  int child_id ;
  int parent_id ; 
  struct MACHINE_RESOURCE *child_mres ;
  struct MACHINE_RESOURCE *parent_mres ;
  struct point_struct bp[MAX_BREAK_POINT_NUM] ; 
  int                 bp_id        ;
  int                 bp_num       ;
  struct point_struct pp[MAX_PASS_POINT_NUM] ;
  int                 pp_id        ;
  int                 pp_num       ;
  int i ;
  
  parent_id = proc_list->cur_id ;
  proc_list->cur_id++ ;
  child_id  = proc_list->cur_id ;

  for( i=0 ; i<MAX_BREAK_POINT_NUM ; i++ ){
    bp[i]=proc_list->proc[child_id].bp[i] ;
  }
  for( i=0 ; i<MAX_PASS_POINT_NUM ; i++ ){
    pp[i]=proc_list->proc[child_id].pp[i] ;
  }
  bp_id =proc_list->proc[child_id].bp_id  ;
  bp_num=proc_list->proc[child_id].bp_num ;
  pp_id =proc_list->proc[child_id].pp_id  ;
  pp_num=proc_list->proc[child_id].pp_num ;
  
  proc_list->proc[child_id]=proc_list->proc[parent_id] ;

  for( i=0 ; i<MAX_BREAK_POINT_NUM ; i++ ){
    proc_list->proc[child_id].bp[i]=bp[i] ;
  }
  for( i=0 ; i<MAX_PASS_POINT_NUM ; i++ ){
    proc_list->proc[child_id].pp[i]=pp[i] ;
  }
  proc_list->proc[child_id].bp_id =bp_id  ;
  proc_list->proc[child_id].bp_num=bp_num ;
  proc_list->proc[child_id].pp_id =pp_id  ;
  proc_list->proc[child_id].pp_num=pp_num ;

  child_mres =&proc_list->proc[child_id] ;
  parent_mres=&proc_list->proc[parent_id] ;
  
  child_mres->SPR[1] = &child_mres->FLGR.xer  ; // XER
  child_mres->SPR[8] = &child_mres->FLGR.lrl  ; // LR
  child_mres->SPR[9] = &child_mres->FLGR.ctrl ; // CTR
  
  child_mres->mem[0x0]=malloc(child_mres->mem_size[0x0]) ;
  if( child_mres->mem[0x0]==NULL ){
    fprintf(simmsgfp,"sim_fork memoly alloc error(size=%d).\n",
	    child_mres->mem_size[0x0] ) ;
    return(MEM_ALLOC_ERROR) ;
  }
  
  memcpy( child_mres->mem[0x0], parent_mres->mem[0x0], parent_mres->mem_size[0x0] ) ;
  child_mres->id = child_id ;
  
  return(NORMAL_EXIT) ;
}

/**************************************************************************
 (2002/05/15)

 bp/ppvZX\̂ɓĂ܂߁AforkŃvZXRs[
 ɂRs[Ă܂soBbp/ppvZX̊O
 ɏôA璆 CKv邽߁AvZXRs[
 Obp/ppۑĂāAvZXRs[Ɍbp/ppɖ߂
 @ɂB[Asł.........
**************************************************************************/
